<?php

/**
 * 
 * @author Christian Doebler <christian.doebler@netways.de>
 *
 */
class IcingaApiSearchIdo
	extends IcingaApiSearch {

	/*
	 * VARIABLES
	 */

	protected $tablePrefix = 'icinga_';

	protected $queryMap = array (
		self::TARGET_HOST =>
			'select
				distinct ${FIELDS}
			from
				${TABLE_PREFIX}objects oh
			inner join ${TABLE_PREFIX}hosts h on h.host_object_id = oh.object_id
			inner join ${TABLE_PREFIX}hoststatus hs on hs.host_object_id = oh.object_id
			inner join ${TABLE_PREFIX}instances i on i.instance_id = h.instance_id
			inner join ${TABLE_PREFIX}host_contactgroups hcg on hcg.host_id = h.host_id
			inner join ${TABLE_PREFIX}contactgroups cg on cg.contactgroup_object_id = hcg.contactgroup_object_id
			inner join ${TABLE_PREFIX}objects ocg on ocg.object_id = hcg.contactgroup_object_id
			inner join ${TABLE_PREFIX}contactgroup_members cgm on cgm.contactgroup_id = cg.contactgroup_id
			inner join ${TABLE_PREFIX}objects oc on oc.object_id = cgm.contact_object_id
			Inner Join ${TABLE_PREFIX}hostgroup_members AS hgm ON hgm.host_object_id = oh.object_id
			Inner Join ${TABLE_PREFIX}hostgroups AS hg ON hg.hostgroup_id = hgm.hostgroup_id
			Inner Join ${TABLE_PREFIX}objects AS ohg ON ohg.object_id = hg.hostgroup_object_id
			where
				oh.objecttype_id = 1
				and ocg.objecttype_id = 11
			${FILTER}
			${GROUPBY}
			${ORDERBY}
			${LIMIT}',
		self::TARGET_SERVICE =>
			'select
				distinct ${FIELDS}
			from
				${TABLE_PREFIX}objects os
			inner join ${TABLE_PREFIX}services s on s.service_object_id = os.object_id
			inner join ${TABLE_PREFIX}instances i on i.instance_id = s.instance_id
			inner join ${TABLE_PREFIX}service_contactgroups scg on scg.service_id = s.service_id
			inner join ${TABLE_PREFIX}contactgroups cg on cg.contactgroup_object_id = scg.contactgroup_object_id
			inner join ${TABLE_PREFIX}contactgroup_members cgm on cgm.contactgroup_id = cg.contactgroup_id
			inner join ${TABLE_PREFIX}objects oc on oc.object_id = cgm.contact_object_id
			inner join ${TABLE_PREFIX}servicestatus ss on ss.service_object_id = os.object_id
			inner join ${TABLE_PREFIX}objects ocg on ocg.object_id = scg.contactgroup_object_id
			inner join ${TABLE_PREFIX}hoststatus hs on hs.host_object_id = s.host_object_id
			inner join ${TABLE_PREFIX}objects oh on oh.object_id = s.host_object_id
			Left Join icinga_servicegroup_members AS sgm ON sgm.service_object_id = os.object_id
			Left Join icinga_servicegroups AS sg ON sg.servicegroup_id = sgm.servicegroup_id
			Left Join icinga_objects AS osg ON osg.object_id = sg.servicegroup_object_id
			where
				oh.objecttype_id = 1
				and os.objecttype_id = 2
				and ocg.objecttype_id = 11
			${FILTER}
			${GROUPBY}
			${ORDERBY}
			${LIMIT}',
		self::TARGET_HOSTGROUP =>
			'select
				distinct ${FIELDS}
			from
				${TABLE_PREFIX}objects ohg
			inner join ${TABLE_PREFIX}hostgroups hg on hg.hostgroup_object_id = ohg.object_id
			inner join ${TABLE_PREFIX}hostgroup_members hgm on hg.hostgroup_id = hgm.hostgroup_id
			inner join ${TABLE_PREFIX}objects oh on oh.object_id = hgm.host_object_id
			where
				ohg.objecttype_id=3
				and oh.objecttype_id=1
			${FILTER}
			${GROUPBY}
			${ORDERBY}
			${LIMIT}',
		self::TARGET_SERVICEGROUP =>
			'select
				distinct ${FIELDS}
			from
				${TABLE_PREFIX}objects osg
			inner join ${TABLE_PREFIX}servicegroups sg on sg.servicegroup_object_id = osg.object_id
			inner join ${TABLE_PREFIX}servicegroup_members sgm on sg.servicegroup_id = sgm.servicegroup_id
			inner join ${TABLE_PREFIX}objects os on os.object_id = sgm.service_object_id
			where
				osg.objecttype_id=4
				and os.objecttype_id=2
			${FILTER}
			${GROUPBY}
			${ORDERBY}
			${LIMIT}',
		self::TARGET_CONTACTGROUP =>
			'select
				distinct ${FIELDS}
			from
				 ${TABLE_PREFIX}objects ocg
			inner join ${TABLE_PREFIX}contactgroups cg on cg.contactgroup_object_id = ocg.object_id
			inner join ${TABLE_PREFIX}contactgroup_members cgm on cgm.contactgroup_id = cg.contactgroup_id
			inner join ${TABLE_PREFIX}objects oc on oc.object_id = cgm.contact_object_id
			where
				ocg.objecttype_id = 11
				and oc.objecttype_id = 10
				${FILTER}
				${GROUPBY}
				${ORDERBY}
				${LIMIT}',
                self::TARGET_TIMEPERIOD =>
                        'select
                                distinct ${FIELDS}
                        from
                                 ${TABLE_PREFIX}objects ot
			inner join ${TABLE_PREFIX}timeperiods t on t.timeperiod_object_id = ot.object_id
			inner join ${TABLE_PREFIX}timeperiod_timeranges tt on tt.timeperiod_id = t.timeperiod_id
			where
				ot.objecttype_id = 9
                                ${FILTER}
                                ${GROUPBY}
                                ${ORDERBY}
                                ${LIMIT}',
		self::TARGET_CUSTOMVARIABLE =>
			'select
				distinct ${FIELDS}
			from 
				${TABLE_PREFIX}customvariables cv
			inner join ${TABLE_PREFIX}customvariablestatus cvs on cv.object_id = cvs.object_id
                                ${FILTER}
                                ${GROUPBY}
                                ${ORDERBY}
                                ${LIMIT}',
		self::TARGET_CONFIG =>
			'select
				${FIELDS}
			from
				${TABLE_PREFIX}configfilevariables cfv
			where 1
				${FILTER}
				${GROUPBY}
				${ORDERBY}
				${LIMIT}',
		self::TARGET_PROGRAM =>
			'select
				${FIELDS}
			from
				${TABLE_PREFIX}processevents pe
			where
				event_type = 100
				${FILTER}
			order by
				event_time desc
			limit 1',
		self::TARGET_LOG => 
			'select
				${FIELDS}
			from
				${TABLE_PREFIX}logentries le
			where 1 
				${FILTER}
				${GROUPBY}
				${ORDERBY}
				${LIMIT}',
		self::TARGET_HOST_STATUS_SUMMARY => 
			'select
				hs.current_state host_state, count(hs.current_state) count
			from
				${TABLE_PREFIX}hoststatus hs
			inner join ${TABLE_PREFIX}objects oh on oh.object_id = hs.host_object_id
			inner join ${TABLE_PREFIX}hosts h on h.host_object_id = oh.object_id
			inner join ${TABLE_PREFIX}instances i on i.instance_id = h.instance_id
			-- inner join ${TABLE_PREFIX}host_contactgroups hcg on hcg.host_id = h.host_id
			-- inner join ${TABLE_PREFIX}contactgroups cg on cg.contactgroup_object_id = hcg.contactgroup_object_id
			-- inner join ${TABLE_PREFIX}objects ocg on ocg.object_id = hcg.contactgroup_object_id
			-- inner join ${TABLE_PREFIX}contactgroup_members cgm on cgm.contactgroup_id = cg.contactgroup_id
			-- inner join ${TABLE_PREFIX}objects oc on oc.object_id = cgm.contact_object_id
			where 1
				${FILTER}
			group by
				hs.current_state
			order by
				hs.current_state',
		self::TARGET_SERVICE_STATUS_SUMMARY =>
			'select
				ss.current_state service_state, count(ss.current_state) count
			from
				${TABLE_PREFIX}servicestatus ss
			inner join ${TABLE_PREFIX}objects os on os.object_id = ss.service_object_id
			inner join ${TABLE_PREFIX}services s on s.service_object_id = os.object_id
			inner join ${TABLE_PREFIX}instances i on i.instance_id = s.instance_id
			-- inner join ${TABLE_PREFIX}service_contactgroups scg on scg.service_id = s.service_id
			-- inner join ${TABLE_PREFIX}contactgroups cg on cg.contactgroup_object_id = scg.contactgroup_object_id
			-- inner join ${TABLE_PREFIX}contactgroup_members cgm on cgm.contactgroup_id = cg.contactgroup_id
			-- inner join ${TABLE_PREFIX}objects oc on oc.object_id = cgm.contact_object_id
			-- inner join ${TABLE_PREFIX}objects ocg on ocg.object_id = scg.contactgroup_object_id
			-- inner join ${TABLE_PREFIX}hoststatus hs on hs.host_object_id = s.host_object_id
			-- inner join ${TABLE_PREFIX}objects oh on oh.object_id = s.host_object_id
			where 1
				${FILTER}
			group by
				ss.current_state
			${ORDERBY:ss.current_state}',
		self::TARGET_HOST_STATUS_HISTORY => 
			'select
				${FIELDS}
			from 
				${TABLE_PREFIX}statehistory sh
			inner join ${TABLE_PREFIX}objects oh on oh.object_id = sh.object_id and oh.objecttype_id=1
			inner join ${TABLE_PREFIX}hosts h on h.host_object_id = oh.object_id
			where 1
				${FILTER}
				${GROUPBY}
				${ORDERBY}
				${LIMIT}',
		self::TARGET_SERVICE_STATUS_HISTORY => 
			'select
				${FIELDS}
			from 
				${TABLE_PREFIX}statehistory sh
			inner join ${TABLE_PREFIX}objects os on os.object_id = sh.object_id and os.objecttype_id=2
			inner join ${TABLE_PREFIX}services s on s.service_object_id = os.object_id
			inner join ${TABLE_PREFIX}objects oh on oh.object_id = s.host_object_id
			inner join ${TABLE_PREFIX}hosts h on h.host_object_id = oh.object_id
			where 1
				${FILTER}
				${GROUPBY}
				${ORDERBY}
				${LIMIT}',
		self::TARGET_HOST_PARENTS =>
			'select
				${FIELDS:ohp.object_id host_parent_object_id, ohp.name1 host_parent_name, oh.object_id host_child_object_id, oh.name1 host_child_name}
			from
				${TABLE_PREFIX}objects ohp
			inner join ${TABLE_PREFIX}host_parenthosts hph on hph.parent_host_object_id = ohp.object_id
			inner join ${TABLE_PREFIX}hosts h on h.host_id = hph.host_id
			inner join ${TABLE_PREFIX}objects oh on oh.object_id = h.host_object_id
			where
				oh.objecttype_id = 1
				and ohp.objecttype_id = 1
				${FILTER}
				${GROUPBY}
				${ORDERBY:host_parent_name asc, host_child_name asc}
				${LIMIT}',
		self::TARGET_NOTIFICATIONS => 
			'select
				${FIELDS}
			from
				${TABLE_PREFIX}notifications n
			Inner Join ${TABLE_PREFIX}objects AS `on` ON `on`.object_id = n.object_id
			Left Join ${TABLE_PREFIX}services AS s ON s.service_object_id = `on`.object_id
			Left Join ${TABLE_PREFIX}hosts ON ${TABLE_PREFIX}hosts.host_object_id = `on`.object_id OR ${TABLE_PREFIX}hosts.host_object_id = s.host_object_id
			Left Join ${TABLE_PREFIX}objects AS oh ON oh.object_id = ${TABLE_PREFIX}hosts.host_object_id
			Left Join ${TABLE_PREFIX}objects AS os ON os.object_id = s.service_object_id
			where
				`on`.is_active =  1
				${FILTER}
				${GROUPBY}
				${ORDERBY:n.start_time ASC}
				${LIMIT}',
		self::TARGET_HOSTGROUP_SUMMARY => 
			'select
				${FIELDS}
			FROM
				${TABLE_PREFIX}hostgroups AS hg
			Inner Join ${TABLE_PREFIX}objects AS ohg ON ohg.object_id = hg.hostgroup_object_id
			Inner Join ${TABLE_PREFIX}hostgroup_members AS hgm ON hgm.hostgroup_id = hg.hostgroup_id
			Inner Join ${TABLE_PREFIX}objects AS oh ON oh.object_id = hgm.host_object_id
			Inner Join ${TABLE_PREFIX}hoststatus AS hs ON hs.host_object_id = oh.object_id
			WHERE
				ohg.is_active =  1
				${FILTER}
				${GROUPBY}
				${ORDERBY:hs.current_state ASC}
				${LIMIT}',
		self::TARGET_SERVICEGROUP_SUMMARY =>
			'select
				${FIELDS}
			FROM
			icinga_servicegroups AS sg
			Inner Join icinga_objects AS osg ON sg.servicegroup_object_id = osg.object_id
			Inner Join icinga_servicegroup_members AS sgm ON sgm.servicegroup_id = sg.servicegroup_id
			Inner Join icinga_objects AS so ON sgm.service_object_id = so.object_id
			Inner Join icinga_servicestatus AS ss ON ss.service_object_id = so.object_id
			WHERE
				osg.is_active = 1
				${FILTER}
				${GROUPBY}
				${ORDERBY:ss.current_state ASC}
				${LIMIT}'
	);

	/*
	 * METHODS
	 */

	/**
	 * class constructor
	 *
	 * @param	void
	 * @return	void
	 * @author	Christian Doebler <christian.doebler@netways.de>
	 */
	public function __construct () {
		parent::__construct();
		return $this;
	}

	/**
	 * sets the table prefix
	 *
	 * @param	string		$prefix				table prefix
	 * @return	void
	 * @author	Christian Doebler <christian.doebler@netways.de>
	 */
	public function setTablePrefix ($prefix = null) {
		$this->tablePrefix = $prefix;
	}

	/**
	 * creates where statement for database query
	 *
	 * @param	void 
	 * @return	array							associative array w/ where statement and corresponding values
	 * @author	Christian Doebler <christian.doebler@netways.de>
	 */
	public function createQueryFilter () {

		$whereStatementArray = array();
		$whereStatementValues = array();

		foreach ($this->searchFilter as $key => $filterData) {

			$tmpStatementArray = array();

			foreach ($filterData as $matchType => $valueArray) {

				// create template for current part of where statement
				$separator = $key . ' ' . $matchType . ' ?';
				$numValues = count($valueArray);
				for ($x = 0; $x < $numValues; $x++) {
					array_push($tmpStatementArray, $separator);
				}

				// populate value array
				$whereStatementValues = array_merge($whereStatementValues, $valueArray);

				// create temporary statement
				$tmpStatement = '(' . implode(' or ', $tmpStatementArray) . ')';

			}

			// extend final where statement
			array_push($whereStatementArray, $tmpStatement);

		}

		// create final array
		$whereStatement = 'and ' . implode(' and ', $whereStatementArray);
		$returnData = array (
			'statement'	=> $whereStatement,
			'values'	=> $whereStatementValues,
		);

		return $returnData;

	}

	/**
	 * applies a search type to search columns
	 * @param	string				$fields			fields to extend by search type
	 * @return	string								modified fields
	 * @author	Christian Doebler <christian.doebler@netways.de>
	 */
	private function applySearchType ($fields) {
		switch ($this->searchType) {
			case IcingaApi::SEARCH_TYPE_COUNT:
				$fieldsArray = explode(' ', $fields);
				$countFieldsArray = count($fieldsArray);
				if ($countFieldsArray > 2) {
					throw new IcingaApiSearchException('applySearchType(): invalid number of columns for use of \'count\'!');
				} else {
					$suffix = 'count';
					if ($countFieldsArray == 2) {
						$suffix .= '_' . $fieldsArray[1];
					}
					$fields = 'count(distinct ' . $fieldsArray[0] . ') ' . $suffix;
				}
				break;
		}
		return $fields;
	}

	/**
	 * replaces query variables by corresponding data
	 * @param	string			$query			query template
	 * @param	string			$variableName	name of query variable to replace by defined values
	 * @return	string							processed query
	 * @author	Christian Doebler <christian.doebler@netways.de>
	 */
	private function replaceQueryVariables ($query, $variableName) {

		$variableValuesPrefix = null;
		$variableValues = false;
		$variableNamePrefix = '${' . $variableName;

		switch ($variableName) {
			case 'FIELDS':
				if (count($this->resultColumns)) {
					$variableValues = $this->applySearchType(implode(',', $this->resultColumns));
				}
				break;
			case 'FILTER':
				// TODO: insert processing of default values
				break;
			case 'GROUPBY':
				// TODO: insert processing of default values
				break;
			case 'ORDERBY':
				$variableValuesPrefix = ' order by ';
				if (count($this->searchOrder)) {
					$variableValues =  implode(',', $this->searchOrder);
				}
				break;
			case 'LIMIT':
				// TODO: insert processing of default values
				break;
		}

		if (strpos($query, $variableNamePrefix . ':') !== false) {
			$fieldPattern = '/\\' . $variableNamePrefix . ':([^}]+)}/';
			preg_match_all($fieldPattern, $query, $fieldDefaultMatches);
		}

		if ($variableValues === false) {
			if (count($fieldDefaultMatches)) {
				$variableValues = $fieldDefaultMatches[1][0];
			} else {
				$variableValues = null;				
			}
		}

		$variableName = (count($fieldDefaultMatches)) ? $fieldDefaultMatches[0][0] : $variableNamePrefix . '}';

		if (empty($variableValues)) {
			$variableValuesPrefix = null;
		}

		$query = str_replace($variableName, $variableValuesPrefix . $variableValues, $query);

		return $query;

	}

	/**
	 * creates and executes database query
	 *
	 * @param	void
	 * @return	boolean							true on success otherwise false
	 * @author	Christian Doebler <christian.doebler@netways.de>
	 */
	public function executeQuery () {

		$success = true;

		if ($this->searchValid()) {

			// create base for query
			$query = $this->queryMap[$this->searchTarget];
			$query = str_replace('${TABLE_PREFIX}', $this->tablePrefix, $query);

			// add query fields
			$query = $this->replaceQueryVariables($query, 'FIELDS');

			// add filter
			if (count($this->searchFilter)) {
				$filterData = $this->createQueryFilter();
				$filterStatement = $filterData['statement'];
				$queryValues = $filterData['values'];
			} else {
				$filterStatement = null;
				$queryValues = array();
			}
			$query = str_replace('${FILTER}', $filterStatement, $query);

			// add 'group by'
			$groupBy = (count($this->searchGroup)) ? (' group by ' . implode(',', $this->searchGroup) . ' ') : null;
			$query = str_replace('${GROUPBY}', $groupBy, $query);

			// add order
			$query = $this->replaceQueryVariables($query, 'ORDERBY');

			// add limit
			$limit = ($this->searchLimit !== false) ? (' limit ' . $this->searchLimit . ' ') : null;
			$query = str_replace('${LIMIT}', $limit, $query);

			$dbResult = $this->connectionObject->query($query, $queryValues);

		} else {

			$success = false;

		}

		return $success;

	}

	/**
	 * (non-PHPdoc)
	 * @see objects/search/IcingaApiSearch#fetch()
	 * @author	Christian Doebler <christian.doebler@netways.de>
	 */
	public function fetch () {
		$class = 'IcingaApiResultIdo';
		$object = new $class;
		if ($this->executeQuery()) {
			$object->setSearchObject($this->connectionObject->connectionStatement);
			if ($this->resultType !== false) {
				$object->setResultType($this->resultType);
			}
			$object->next();
		}
		parent::fetch();
		return $object;
	}

}

// extend exceptions
class IcingaApiSearchIdoException extends IcingaApiSearchException {}

?>
